vbuilder.sh.in 30 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025
  1. #!/bin/bash
  2. # -*- coding: utf-8-unix -*-
  3. TEXTDOMAIN=vbootstrap
  4. TEXTDOMAINDIR=/usr/share/locale
  5. Usage(){
  6. cat<<EOF
  7. $(basename $0) @@VBUILDER_VERSION@@ $(echo $([ -z "@@VBUILDER_REVISION@@" ] || echo "(r@@VBUILDER_REVISION@@)"))
  8. Usage: $(basename $0) {--profile [profile]} {--version [version]} {--arch [arch]} {--category [categories]} {--fetch-url [fetch_url]} {--dist-upgrade} {--target [target]} {--no-build-essential} {--with-compat32} {--rpmbuild-define [macro_expr]} {--rpmbuild-with [bcond_with]} {--rpmbuild-without [bcond_with]} {--sign} {--no-install} {--debug} {--help} {--bootstrap-dir [directory]} {--unionfs-dir [directory]} {--cache-dir [directory]} {--built-rpms-dir [directory]} {clean|build|build-rpm [src.rpm]|install-rpm [arch.rpm|package]|remove-rpm [package]}
  9. EOF
  10. echo $"
  11. Options:
  12. --profile: set a profile
  13. --version: set [version] (default: ${VERSION})
  14. --arch: set [arch] (default: ${UARCH})
  15. --category: set [categories] (default: ${CATEGORIES})
  16. --fetch-url: set [fetch_url] to fetch packages (default: ${VBOOTSTRAP_FETCH_URL})
  17. --dist-upgrade: make VineSeed bootstrap via ${STABLE_VERSION}
  18. --unionfs: cover a bootstrap with unionfs
  19. --target: build rpms with [target]
  20. --no-build-essential: do not install build-essential
  21. --with-compat32: build rpms with compat32 on bootstrap
  22. --rpmbuild-define: give a option --define [macro_expr] to rpmbuild
  23. --rpmbuild-with: give a option --with [bcond_with] to rpmbuild
  24. --rpmbuild-without: give a option --without [bcond_with] to rpmbuild
  25. --sign: sign built rpms
  26. --no-install: build only a source rpm - do NOT install a built rpm
  27. --login: login in chroot as root user
  28. --bootstrap-dir: set a bootstrap directory (default: ${VBOOTSTRAP_DIR})
  29. --unionfs-dir: set a directory to store unionfs images of vbootstrap (default: ${UNIONFS_DIR})
  30. --cache-dir: set a directory to cache rpms (default: ${CACHE_DIR})
  31. --built-rpms-dir: set a directory to store built rpms in chroot (default: ${BUILT_RPMS_DIR})
  32. --debug: enable debug mode
  33. --help: show this help
  34. "
  35. echo $"
  36. Actions:
  37. clean: clean the bootstrap of [version]
  38. build: build a bootstrap of [version]
  39. build-rpm: build [src.rpm] on a bootstrap
  40. install-rpm: install [arch.rpm|package] on a bootstrap
  41. remove-rpm: remove [package] on a bootstrap
  42. "
  43. echo $"
  44. Examples:
  45. * make a clean/plain build environment on the current archtecture:
  46. $(basename $0) clean build
  47. * build rpms from the specified source rpm:
  48. $(basename $0) build-rpm [src.rpm]
  49. * make a plain build environment for Vine Linux 5.2:
  50. $(basename $0) --version 5.2 clean build
  51. * make a i386 chroot on x86_64:
  52. $(basename $0) --arch i386 clean build
  53. * build a kernel package with target i686:
  54. $(basename $0) --target i686 build-rpm [kernel src.rpm]
  55. * build a compat32 package:
  56. $(basename $0) --arch i386 --with-compat32 build-rpm [src.rpm]
  57. "
  58. /usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*//
  59. ## TODO: output supported profiles and their names/comments
  60. }
  61. ##############################################################################
  62. initialize-variables(){
  63. ## set boolian variables
  64. with_profile=0
  65. with_setup_vbootstrap=0
  66. with_dist_upgrade=0
  67. with_unionfs=0
  68. with_sign=0
  69. with_no_install=0
  70. with_login=0
  71. with_debug=0
  72. with_actions=0
  73. with_ix86_on_x86_64=0
  74. with_category_main=0
  75. with_category_plus=0
  76. with_category_nonfree=0
  77. with_category_test=0
  78. with_category_proposed_updates=0
  79. with_category_security=0
  80. with_build_essential=1
  81. return 0
  82. }
  83. check-parameter(){
  84. [ -z "$*" ] && Usage && return 1
  85. while [ ! -z "$*" ]; do
  86. case $1 in
  87. --help|help)
  88. setup-vbuilder ||:
  89. Usage
  90. return 1
  91. ;;
  92. --profile)
  93. shift
  94. with_profile=1
  95. PROFILE=$1
  96. check-next-parameter $1 || return 1
  97. ;;
  98. --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
  99. [ $with_actions -eq 1 ] && \
  100. echo $"E: You can give no more options after actions" && \
  101. return 1
  102. shift
  103. check-next-parameter $1 || return 1
  104. ;;
  105. --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
  106. [ $with_actions -eq 1 ] && \
  107. echo $"E: You can give no more options after actions" && \
  108. return 1
  109. ;;
  110. --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
  111. with_actions=1
  112. shift
  113. check-next-parameter $1 || return 1
  114. ;;
  115. --build|build|--clean|clean)
  116. with_actions=1
  117. ;;
  118. *)
  119. echo $"E: Missing some parameters after $1"
  120. return 1
  121. ;;
  122. esac
  123. shift
  124. done
  125. [ $with_actions -eq 0 ] && \
  126. echo $"E: You must give at least one action" && return 1
  127. return 0
  128. }
  129. check-next-parameter(){
  130. [ -z "$1" ] && echo $"E: Missing some parameters after $1" && return 1
  131. [ $(echo $1 | grep '^-') ] && \
  132. echo $"E: Missing some parameters after $1" && return 1
  133. return 0
  134. }
  135. ## NOTE: setup-vbuilder() loads
  136. ## - system wide configurations (from /etc/vbootstrap/vbuilder.conf)
  137. ## - given profile (from /etc/vbootstrap/profile.d/*.conf)
  138. ## - given command-line parameters
  139. ## where given command-line parameters override the settings given profile,
  140. ## and the settings given profile override system wide settings.
  141. ## If you use a profile of vbuilder, you may not override the settings
  142. ## given profile.
  143. setup-vbuilder(){
  144. ## check $SUDO_USER and $USERHELPER_UID
  145. RPM_SIGN_USER=$SUDO_USER
  146. if [ -z "${RPM_SIGN_USER}" ]; then
  147. [ -z "${USERHELPER_UID}" ] && \
  148. echo $"W: \$SUDO_USER and \$USERHELPER_UID are empty" && \
  149. return 1
  150. RPM_SIGN_USER=$(getent passwd $USERHELPER_UID | cut -d":" -f1)
  151. fi
  152. ## get $RPM_SIGN_USER's home directory
  153. HOME=$(getent passwd $RPM_SIGN_USER | cut -d":" -f6)
  154. ## load default settings
  155. VBUILDER_CONF=/etc/vbootstrap/vbuilder.conf
  156. if [ -r $VBUILDER_CONF ]; then
  157. . $VBUILDER_CONF
  158. [ $? -eq 1 ] && return 1
  159. fi
  160. [ -z "${CATEGORIES}" ] && \
  161. CATEGORIES=@@VBUILDER_CATEGORIES@@
  162. [ -z "${VBOOTSTRAP_FETCH_URL}" ] && \
  163. VBOOTSTRAP_FETCH_URL=@@VBUILDER_VBOOTSTRAP_FETCH_URL@@
  164. [ -z "${VBOOTSTRAP_DIR}" ] && \
  165. VBOOTSTRAP_DIR=@@VBUILDER_VBOOTSTRAP_DIR@@
  166. [ -z "${UNIONFS_DIR}" ] && \
  167. UNIONFS_DIR=@@VBUILDER_UNIONFS_DIR@@
  168. [ -z "${CACHE_DIR}" ] && \
  169. CACHE_DIR=@@VBUILDER_CACHE_DIR@@
  170. [ -z "${BUILT_RPMS_DIR}" ] && \
  171. BUILT_RPMS_DIR=@@VBUILDER_BUILT_RPMS_DIR@@
  172. ## set default version for vbootstrap
  173. VERSION=@@VBUILDER_DEFAULT_VERSION@@
  174. ## load profile
  175. if [ ${with_profile} -eq 1 ]; then
  176. [ ! -r /etc/vbootstrap/profile.d/${PROFILE}.conf ] && \
  177. echo $"E: No such profile found: ${PROFILE}" && return 1
  178. . /etc/vbootstrap/profile.d/${PROFILE}.conf
  179. [ $? -eq 1 ] && return 1
  180. fi
  181. ## set current stable relase version
  182. STABLE_VERSION=@@VBUILDER_STABLE_VERSION@@
  183. ## set default chroot archtecture
  184. UARCH=$(uname -i)
  185. case "${UARCH}" in
  186. arm*)
  187. UARCH="arm"
  188. ;;
  189. esac
  190. return 0
  191. }
  192. setup-vbootstrap(){
  193. if [ ${with_setup_vbootstrap} -eq 0 ]; then
  194. with_setup_vbootstrap=1
  195. ## check debug mode
  196. [ ${with_debug} -eq 1 ] && \
  197. cat $VBUILDER_CONF && \
  198. set && set -x
  199. ## check some directories
  200. ## Note: create $BUILT_RPMS_DIR in RPM_Build()
  201. [ -d $VBOOTSTRAP_DIR ] || mkdir -p $VBOOTSTRAP_DIR
  202. [ -d $CACHE_DIR ] || mkdir -p $CACHE_DIR
  203. ## check chroot version
  204. case ${VERSION} in
  205. 4.2|5.2|6.0|VineSeed)
  206. ;;
  207. *)
  208. echo $"E: ${VERSION} is NOT supported"
  209. return 1
  210. ;;
  211. esac
  212. case "${VARCH}" in
  213. arm*)
  214. VARCH="arm"
  215. ;;
  216. esac
  217. ## check a chroot archtecture
  218. if [ -z ${VARCH} ]; then
  219. VARCH=${UARCH}
  220. else
  221. case "${VARCH}" in
  222. i386|x86_64)
  223. [ "${UARCH}" = "ppc" -o "${UARCH}" = "arm" ] && \
  224. echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
  225. ;;
  226. ppc)
  227. [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "arm" ] && \
  228. echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
  229. ;;
  230. arm)
  231. [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "ppc" ] && \
  232. echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
  233. ;;
  234. esac
  235. fi
  236. ##!! 4.2 is NO support on VARCH=x86_64 or VARCH=arch
  237. if [ "${VERSION}" = "4.2" ]; then
  238. if [ "${VARCH}" = "x86_64" -o "${VARCH}" = "arm" ]; then
  239. echo $"E: ${VERSION}_${VARCH} is NOT supported"
  240. return 1
  241. fi
  242. fi
  243. ## set base profile <version>_<arch>
  244. BASE_PROFILE=${VERSION}_${VARCH}
  245. ## check support ${BASE_PROFILE}
  246. if [ -z "$(/usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*// | grep -m 1 ${BASE_PROFILE})" ]; then
  247. echo $"E: ${BASE_PROFILE} is NOT supported"
  248. return 1
  249. fi
  250. ## check ${VERSION} equals VineSeed*, when with_dist_upgrade=1
  251. if [ $with_dist_upgrade -eq 1 ]; then
  252. if [ "${VERSION}" != "VineSeed" ]; then
  253. echo $"E: version ${VERSION} does not support --dist-upgrade option"
  254. return 1
  255. fi
  256. fi
  257. ## support i386 chroot on x86_64 below:
  258. [ "${UARCH}" = "x86_64" -a "${VARCH}" = "i386" ] && \
  259. with_ix86_on_x86_64=1
  260. ## check apt categories
  261. ## "main" category is unconditionally permited
  262. with_category_main=1
  263. for cat in $(echo ${CATEGORIES} | sed -e "s/,/ /"g); do
  264. case $cat in
  265. main)
  266. with_category_main=1
  267. ;;
  268. plus)
  269. with_category_plus=1
  270. ;;
  271. nonfree)
  272. with_category_nonfree=1
  273. ;;
  274. test)
  275. ## "test" category only exists in VineSeed
  276. [ "${VERSION}" = "VineSeed" ] || \
  277. echo $"E: No such category exists: $cat" && return 1
  278. with_category_test=1
  279. ;;
  280. proposed-updates)
  281. ##!! "proposed-updates" category does not exist in 4.2
  282. [ "${VERSION}" = "4.2" ] && \
  283. echo $"E: No such category exists: $cat" && return 1
  284. with_category_proposed_updates=1
  285. ;;
  286. security)
  287. ## "security" category does not exist in VineSeed
  288. [ "${VERSION}" = "VineSeed" ] && \
  289. echo $"E: No such category exists: $cat" && return 1
  290. with_category_security=1
  291. ;;
  292. *)
  293. echo $"E: No such category exists: $cat" && return 1
  294. ;;
  295. esac
  296. done
  297. ## check build target option ${TARGET}
  298. if [ ! -z "${TARGET}" ]; then
  299. RPM_TARGET_LIST="$(cat /usr/lib/rpm/rpmrc | grep arch_canon: | sed -e "s/arch_canon:[[:blank:]]*\(.*\):.*/\1/")"
  300. RPM_TARGET_LIST="${RPM_TARGET_LIST} noarch"
  301. if [ -z "$(echo ${RPM_TARGET_LIST} | grep ${TARGET})" ]; then
  302. echo $"E: rpm build target ${TARGET} is NOT supported"
  303. return 1
  304. fi
  305. fi
  306. ## set ${RPM_PKG_ARCH_LIST}
  307. RPM_PKG_ARCH_LIST=" \
  308. RPMS/i386 RPMS/i486 RPMS/i586 RPMS/i686 RPMS/x86_64 RPMS/ppc \
  309. RPMS/noarch \
  310. RPMS/armv3l RPMS/armv4l RPMS/armv4tl \
  311. RPMS/armv5tejl RPMS/armv5tel RPMS/armv6l RPMS/armv7l \
  312. SRPMS"
  313. [ -z "${TARGET}" ] || \
  314. RPM_PKG_ARCH_LIST="RPMS/${TARGET} ${RPM_PKG_ARCH_LIST}"
  315. fi
  316. ## set global variables
  317. BUILD_USER=vbuilder
  318. BUILD_DIR=/home/${BUILD_USER}/rpm
  319. if [ ${with_profile} -eq 1 ]; then
  320. BUILD_ROOT=${VBOOTSTRAP_DIR}/${PROFILE}
  321. UNIONFS_ROOT=${UNIONFS_DIR}/${PROFILE}
  322. else
  323. BUILD_ROOT=${VBOOTSTRAP_DIR}/${BASE_PROFILE}
  324. UNIONFS_ROOT=${UNIONFS_DIR}/${BASE_PROFILE}
  325. fi
  326. ARCHIVES_DIR=${BUILD_ROOT}/var/cache/apt/archives
  327. EXTERNAL_ARCHIVES_DIR=${CACHE_DIR}/${BASE_PROFILE}/apt/archives
  328. __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} /bin/sh -c -l"
  329. mkdir -p $VBOOTSTRAP_DIR
  330. return 0
  331. }
  332. setup-vbootstrap-rpm(){
  333. setup-vbootstrap || return 1
  334. ## check ${BUILD_ROOT}
  335. [ -d ${BUILD_ROOT} ] || Build
  336. ## setarch ix86 if ix86 chroot on x86_64 host
  337. [ $with_ix86_on_x86_64 -eq 1 ] && \
  338. __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH} /bin/sh -c -l"
  339. DIST_RELEASE=$(cat ${BUILD_ROOT}/etc/vine-release | cut -f3 -d" " | cut -f1 -d.)
  340. if [ -f $RPM_PKG ]; then
  341. BASE_RPM_PKG=$(basename $RPM_PKG)
  342. cp -f $RPM_PKG $BUILD_ROOT${BUILD_DIR}
  343. else
  344. BASE_RPM_PKG=$RPM_PKG
  345. fi
  346. return 0
  347. }
  348. ## recover apt-get data on host/chroot
  349. apt-get-update(){
  350. case $1 in
  351. --host)
  352. echo -n $"apt-get update on host ... "
  353. apt-get -qq update > /dev/null 2>&1
  354. echo $"done."
  355. ;;
  356. --chroot)
  357. echo -n $"apt-get update on chroot ... "
  358. $__chroot_sh 'apt-get -qq update' > /dev/null 2>&1
  359. echo $"done."
  360. ;;
  361. *)
  362. echo apt-get-update: unknown option $1
  363. exit 1
  364. ;;
  365. esac
  366. }
  367. ## mount-chroot {|--umount} [file system|name]
  368. ## support file systems: /home /tmp /sys /proc /dev/shm /dev/pts /dev
  369. ## support names: vfs archives_dir
  370. ## NOTE: /tmp needs for applications which use X
  371. ## vfs is virtual file systems
  372. ## archives_dir uses to mount ${EXTERNAL_ARCHIVES_DIR} to ${ARCHIVES_DIR}
  373. ## unionfs_dir covers ${BUILD_ROOT} with unionfs
  374. mount-chroot(){
  375. if [ "$1" = "--umount" ]; then
  376. mount-chroot-umount $2 || return 1
  377. else
  378. mount-chroot-mount $1 || return 1
  379. fi
  380. return 0
  381. }
  382. ## mount-chroot-umount [file system|name]
  383. mount-chroot-umount(){
  384. local fs=$1
  385. case $fs in
  386. /home|/tmp|/sys|/proc|/dev/shm|/dev/pts|/dev)
  387. [ -d ${BUILD_ROOT}${fs} ] || return 1
  388. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] || \
  389. umount ${BUILD_ROOT}${fs}
  390. if [ ! -z "$(mount | grep ${BUILD_ROOT}${fs})" ]; then
  391. echo $"Retry lazy unmount ${BUILD_ROOT}${fs} ... "
  392. umount -l ${BUILD_ROOT}${fs}
  393. echo $"done."
  394. fi
  395. ;;
  396. vfs)
  397. for dir in /sys /proc /dev/shm /dev/pts /dev; do
  398. mount-chroot-umount ${dir} || return 1
  399. done
  400. ;;
  401. archives_dir)
  402. [ -d ${ARCHIVES_DIR} ] || return 1
  403. [ -z "$(mount | grep ${ARCHIVES_DIR})" ] || \
  404. umount ${ARCHIVES_DIR}
  405. ;;
  406. unionfs_dir)
  407. [ -d ${BUILD_ROOT} ] || return 1
  408. [ -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs)')" ] || \
  409. umount ${BUILD_ROOT}
  410. if [ ! -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs)')" ]; then
  411. echo $"Retry lazy unmount ${BUILD_ROOT} ... "
  412. umount -l ${BUILD_ROOT}
  413. echo $"done."
  414. fi
  415. ;;
  416. *)
  417. echo mount-chroot-umount: unknown file system $fs
  418. exit 1
  419. ;;
  420. esac
  421. return 0
  422. }
  423. ## mount-chroot-mount [file system|name]
  424. mount-chroot-mount(){
  425. local fs=$1
  426. case $fs in
  427. /home)
  428. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  429. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  430. mount -o _netdev,rbind ${fs} ${BUILD_ROOT}${fs}
  431. ;;
  432. /tmp|/dev)
  433. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  434. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  435. mount --bind -o _netdev ${fs} ${BUILD_ROOT}${fs}
  436. ;;
  437. /sys)
  438. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  439. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  440. mount -o _netdev -t sysfs vbuildersysfs ${BUILD_ROOT}${fs}
  441. ;;
  442. /proc)
  443. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  444. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  445. mount -o _netdev -t proc vbuilderproc ${BUILD_ROOT}${fs}
  446. ;;
  447. /dev/shm)
  448. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  449. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  450. mount -o _netdev -t tmpfs vbuildertmpfs ${BUILD_ROOT}${fs}
  451. ;;
  452. /dev/pts)
  453. [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
  454. [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
  455. mount -o gid=5,mode=620,_netdev -t devpts vbuilderdevpts ${BUILD_ROOT}${fs}
  456. ;;
  457. vfs)
  458. for dir in /dev /dev/pts /dev/shm /proc /sys; do
  459. mount-chroot-mount ${dir} || return 1
  460. done
  461. ;;
  462. archives_dir)
  463. [ -d ${EXTERNAL_ARCHIVES_DIR} ] || mkdir -p ${EXTERNAL_ARCHIVES_DIR}
  464. [ -d ${ARCHIVES_DIR} ] || mkdir -p ${ARCHIVES_DIR}
  465. [ -z "$(mount | grep ${ARCHIVES_DIR})" ] && \
  466. mount --bind -o _netdev ${EXTERNAL_ARCHIVES_DIR} ${ARCHIVES_DIR}
  467. [ -d ${ARCHIVES_DIR}/partial ] || mkdir -p ${ARCHIVES_DIR}/partial
  468. ;;
  469. unionfs_dir)
  470. if [ $with_unionfs -eq 1 ]; then
  471. [ -d ${UNIONFS_ROOT} ] || mkdir -p ${UNIONFS_ROOT}
  472. if ( /sbin/modprobe aufs >& /dev/null ) ; then
  473. [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
  474. mount -t aufs -o br=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro aufs ${BUILD_ROOT}
  475. else
  476. [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
  477. mount -t unionfs -o dirs=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro unionfs ${BUILD_ROOT}
  478. unionctl ${BUILD_ROOT} --list
  479. fi
  480. fi
  481. ;;
  482. *)
  483. echo mount-chroot-mount: unknown file system $fs
  484. exit 1
  485. ;;
  486. esac
  487. return 0
  488. }
  489. ## TODO: support spec-validator
  490. ## spec-validator [spec file]
  491. spec-validator(){
  492. echo
  493. return 0
  494. }
  495. ##############################################################################
  496. Clean(){
  497. setup-vbootstrap || return 1
  498. # mount-chroot --umount /home
  499. mount-chroot --umount /tmp
  500. mount-chroot --umount /dev/shm
  501. mount-chroot --umount /dev/pts
  502. mount-chroot --umount /proc
  503. mount-chroot --umount archives_dir
  504. mount-chroot --umount unionfs_dir
  505. apt-get-update --host
  506. ## We remark that we first remove /, and secondly remove /.
  507. ## If we directly remove /, we obtained some non-empty directories:
  508. ## /dev/.udev/rules.d.
  509. if [ $with_unionfs -eq 1 ]; then
  510. if [ -d ${UNIONFS_ROOT} ]; then
  511. echo -n $"Cleaning build root ${UNIONFS_ROOT} via unionfs ... "
  512. rm -rf ${UNIONFS_ROOT} 2>/dev/null
  513. rm -rf ${UNIONFS_ROOT}
  514. echo $"done."
  515. fi
  516. else
  517. if [ -d ${BUILD_ROOT} ]; then
  518. echo -n $"Cleaning build root ${BUILD_ROOT} ... "
  519. rm -rf ${BUILD_ROOT} 2>/dev/null
  520. rm -rf ${BUILD_ROOT}
  521. echo $"done."
  522. fi
  523. fi
  524. echo $"Cleanup a build farm for ${BUILD_ROOT} done."
  525. return 0
  526. }
  527. Build(){
  528. setup-vbootstrap || return 1
  529. if [ $with_dist_upgrade -eq 1 ]; then
  530. ## make bootstrap of ${STABLE_VERSION}
  531. /usr/sbin/vbootstrap \
  532. $(echo ${BASE_PROFILE} | sed -e "s/VineSeed/${STABLE_VERSION}/") \
  533. ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
  534. egrep -v -e '^W: Duplicate sources.list entry' \
  535. -e '^W: .*apt-get update'
  536. ## aim apt-line to VineSeed
  537. sed -i "s/apt ${STABLE_VERSION}/apt VineSeed/g" \
  538. ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
  539. else
  540. /usr/sbin/vbootstrap \
  541. ${BASE_PROFILE} ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
  542. egrep -v -e '^W: Duplicate sources.list entry' \
  543. -e '^W: .*apt-get update'
  544. fi
  545. mount-chroot /proc
  546. mount-chroot archives_dir
  547. mount-chroot /dev/pts
  548. mount-chroot /dev/shm
  549. # mount-chroot /tmp
  550. # mount-chroot /home
  551. ##!! 4.2 has no apt-sourceslist-{plus,nonfree,proposed-updates} packages
  552. case ${VERSION} in
  553. 4.2)
  554. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list
  555. sed -i -e 's/main plus updates nonfree *$/$(echo ${CATEGORIES} | sed -e "s/,/ /"g) updates/g' ${BUILD_ROOT}/etc/apt/sources.list
  556. $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
  557. # [ $with_category_security -eq 1 ] && \
  558. # echo
  559. ;;
  560. 5.2|@@VBUILDER_STABLE_VERSION@@)
  561. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
  562. $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
  563. [ $with_category_plus -eq 1 ] && \
  564. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
  565. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
  566. [ $with_category_nonfree -eq 1 ] && \
  567. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
  568. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
  569. [ $with_category_proposed_updates -eq 1 ] && \
  570. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-proposed-updates' && \
  571. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/proposed-updates.list
  572. # [ $with_category_security -eq 1 ] && \
  573. # echo
  574. ;;
  575. VineSeed)
  576. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
  577. $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
  578. [ $with_category_plus -eq 1 ] && \
  579. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
  580. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
  581. [ $with_category_nonfree -eq 1 ] && \
  582. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
  583. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
  584. [ $with_category_test -eq 1 ] && \
  585. $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-test' && \
  586. sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/test.list
  587. ;;
  588. esac
  589. [ $with_dist_upgrade -eq 1 ] && \
  590. $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
  591. [ $with_build_essential -eq 1 ] && \
  592. $__chroot_sh 'apt-get -qq -y install build-essential'
  593. $__chroot_sh 'apt-get -qq -y install etcskel shadow-utils'
  594. $__chroot_sh 'cd /dev && /sbin/MAKEDEV console'
  595. $__chroot_sh 'cd /dev && /sbin/MAKEDEV ptmx'
  596. $__chroot_sh 'cd /dev && /sbin/MAKEDEV null'
  597. $__chroot_sh 'cd /dev && /sbin/MAKEDEV zero'
  598. $__chroot_sh 'cd /dev && /sbin/MAKEDEV random'
  599. $__chroot_sh 'cd /dev && /sbin/MAKEDEV urandom'
  600. $__chroot_sh 'cd /dev && mkdir -p shm && chmod 777 shm'
  601. $__chroot_sh 'cd /dev && mkdir -p pts && chmod 755 pts'
  602. $__chroot_sh '/usr/sbin/pwconv'
  603. $__chroot_sh "/usr/sbin/useradd ${BUILD_USER}"
  604. ##!! for rpm-4.8.0 or higher
  605. ##!! (See http://trac.vinelinux.org/wiki/Vine6/AboutUpdateToolchain)
  606. if [ "${VERSION}" = "VineSeed" ]; then
  607. $__chroot_sh "sed -i -e 's/^%_topdir/#%_topdir/' /home/${BUILD_USER}/.rpmmacros"
  608. fi
  609. ## set local repositories (profile only)
  610. if [ ${with_profile} -eq 1 ]; then
  611. if [ ! -z "${LOCAL_REPOS}" ]; then
  612. cat >${BUILD_ROOT}/etc/apt/sources.list.d/local.list<<EOF
  613. ${LOCAL_REPOS}
  614. EOF
  615. $__chroot_sh "apt-get update"
  616. fi
  617. ## additional base packages
  618. [ ! -z "${ADD_BASE_PKGS}" ] && \
  619. $__chroot_sh "apt-get -y install ${ADD_BASE_PKGS}"
  620. fi
  621. # mount-chroot --umount /home
  622. # mount-chroot --umount /tmp
  623. mount-chroot --umount /dev/shm
  624. mount-chroot --umount /dev/pts
  625. mount-chroot --umount archives_dir
  626. mount-chroot --umount /proc
  627. apt-get-update --host
  628. echo $"Making a build farm for ${BUILD_ROOT} done."
  629. return 0
  630. }
  631. RPM_Remove(){
  632. setup-vbootstrap-rpm || return 1
  633. mount-chroot unionfs_dir
  634. mount-chroot archives_dir
  635. mount-chroot /proc
  636. mount-chroot /dev/pts
  637. mount-chroot /dev/shm
  638. apt-get-update --chroot
  639. [ -f $RPM_PKG ] && \
  640. echo $"E: $RPM_PKG is not a package name" && return 1
  641. $__chroot_sh "apt-get -y remove $BASE_RPM_PKG"
  642. mount-chroot --umount /dev/shm
  643. mount-chroot --umount /dev/pts
  644. mount-chroot --umount /proc
  645. mount-chroot --umount archives_dir
  646. mount-chroot --umount unionfs_dir
  647. apt-get-update --host
  648. return 0
  649. }
  650. RPM_Install(){
  651. setup-vbootstrap-rpm || return 1
  652. mount-chroot unionfs_dir
  653. mount-chroot archives_dir
  654. mount-chroot /proc
  655. mount-chroot /dev/pts
  656. mount-chroot /dev/shm
  657. apt-get-update --chroot
  658. [ $with_category_nonfree -eq 1 ] && \
  659. [ ! -z "$(echo $BASE_RPM_PKG | grep -e 'self-build-' -e 'install-assist-')" ] && \
  660. $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
  661. $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BASE_RPM_PKG"
  662. mount-chroot --umount /dev/shm
  663. mount-chroot --umount /dev/pts
  664. mount-chroot --umount /proc
  665. mount-chroot --umount archives_dir
  666. mount-chroot --umount unionfs_dir
  667. apt-get-update --host
  668. return 0
  669. }
  670. RPM_Build(){
  671. [ ! -f ${RPM_PKG} ] && \
  672. echo $"E: No such file found: ${RPM_PKG}" && return 1
  673. ## check the extension of given $RPM_PKG
  674. local RPM_PKG_EXT=${RPM_PKG##*.}
  675. case ${RPM_PKG_EXT} in
  676. spec)
  677. ## In this case,
  678. ## the file ${RPM_PKG} is a spec file!
  679. # spec-validator ${RPM_PKG} || return 1
  680. # return 1
  681. ## We assign the variable ${RPM_PKG}
  682. ## the src.rpm generated by the spec file ${RPM_PKG}.
  683. RPM_PKG=$(rpm -E "%{_srcrpmdir}")/$(rpm -q --qf "%{name}-%{version}-%{release}\n" --specfile ${RPM_PKG} | head -n 1).src.rpm
  684. ;;
  685. rpm)
  686. RPM_PKG_EXT=$(echo ${RPM_PKG} | sed -e "s|.*\.\(src\.rpm\)$|\1|")
  687. [ "${RPM_PKG_EXT}" != "src.rpm" ] && \
  688. echo $"E: $RPM_PKG is NOT a source RPM package" && return 1
  689. ;;
  690. *)
  691. echo $"The action build-rpm cannot work such extension: ${RPM_PKG_EXT}"
  692. return 1
  693. ;;
  694. esac
  695. setup-vbootstrap-rpm || return 1
  696. mount-chroot unionfs_dir
  697. mount-chroot archives_dir
  698. mount-chroot /proc
  699. mount-chroot /dev/pts
  700. mount-chroot /dev/shm
  701. apt-get-update --chroot
  702. [ ! -f ${RPM_PKG} ] && \
  703. echo $"E: No such file found: ${RPM_PKG}" && return 1
  704. RPM_PKG_USER=$(stat -c %U $RPM_PKG)
  705. RPM_PKG_GROUP=$(stat -c %G $RPM_PKG)
  706. [ ! -z "${SUDO_UID}" ] && RPM_PKG_USER=${SUDO_UID}
  707. [ ! -z "${SUDO_GID}" ] && RPM_PKG_GROUP=${SUDO_GID}
  708. local __install="install -p -v -o ${RPM_PKG_USER} -g ${RPM_PKG_GROUP}"
  709. ## make src.rpm for $VERSION
  710. $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpm -ivh $BASE_RPM_PKG'"
  711. $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpmbuild -bs --nodeps --clean --rmsource --rmspec $RPM_OPTS ${BUILD_DIR}/SPECS/*.spec'"
  712. ## change ${DIST_RELEASE}
  713. BASE_RPM_PKG=$(echo $BASE_RPM_PKG | sed -e "s/vl[0-9]*\([A-Za-z]*[0-9A-Za-z]*\)\./vl${DIST_RELEASE}\1\./")
  714. ## rebuild $BASE_RPM_PKG on ${DIST_RELEASE}
  715. $__chroot_sh "cd ${BUILD_DIR}/SRPMS && apt-get -o APT::Install::Virtual=true -y build-dep $BASE_RPM_PKG"
  716. $__chroot_sh "cd ${BUILD_DIR}/SRPMS && su ${BUILD_USER} -c 'rpmbuild --rebuild $RPM_OPTS $BASE_RPM_PKG'"
  717. BUILT_RPMS_LIST=$(find $BUILD_ROOT${BUILD_DIR}/RPMS -type f -regex '.*\.rpm' | sed -e s@${BUILD_ROOT}@@g -e 's|.*\/compat32-.*||g' -e 's|.*\/.*\.src\.rpm||g' -e 's/$/ \\/g')
  718. [ $with_category_nonfree -eq 1 ] && \
  719. [ ! -z "$(echo $BUILT_RPMS_LIST | grep -e 'self-build-' -e 'install-assist-')" ] && \
  720. $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
  721. [ $with_no_install -eq 0 ] && \
  722. $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BUILT_RPMS_LIST"
  723. ## copy built rpms to ${HOME}/rpm/ for each archtectures
  724. echo $"Copying built rpms to ${BUILT_RPMS_DIR} for each archtectures ... "
  725. for i in $RPM_PKG_ARCH_LIST; do
  726. [ -d $BUILD_ROOT${BUILD_DIR}/${i} ] || continue
  727. if [ ! -d ${BUILT_RPMS_DIR}/${VERSION}/${i} ]; then
  728. $__install -d ${BUILT_RPMS_DIR}/${VERSION}/${i}/
  729. chown -R ${RPM_PKG_USER}:${RPM_PKG_GROUP} ${BUILT_RPMS_DIR}
  730. fi
  731. find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' \
  732. -exec $__install -m0644 {} ${BUILT_RPMS_DIR}/${VERSION}/${i}/ \;
  733. done
  734. mount-chroot --umount /dev/shm
  735. mount-chroot --umount /dev/pts
  736. mount-chroot --umount /proc
  737. mount-chroot --umount archives_dir
  738. mount-chroot --umount unionfs_dir
  739. apt-get-update --host
  740. echo $"done."
  741. return 0
  742. }
  743. RPM_Sign(){
  744. [ $with_sign -eq 1 ] || return 1
  745. setup-vbootstrap || return 1
  746. [ -d ${BUILD_ROOT} ] || Build
  747. mount-chroot unionfs_dir
  748. echo $"Signing built rpms using ${RPM_SIGN_USER}'s key: "
  749. su $RPM_SIGN_USER -c "rpmsign --addsign $(for i in $RPM_PKG_ARCH_LIST; do find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' 2>/dev/null; done | sed -e s,$BUILD_ROOT${BUILD_DIR},${BUILT_RPMS_DIR}/${VERSION},g -e 's/$/ \\/g')"
  750. mount-chroot --umount unionfs_dir
  751. return 0
  752. }
  753. Login_Chroot(){
  754. [ $with_login -eq 1 ] || return 1
  755. setup-vbootstrap || return 1
  756. __chroot="/usr/sbin/chroot ${BUILD_ROOT}"
  757. ## setarch ix86 if ix86 chroot on x86_64 host
  758. [ $with_ix86_on_x86_64 -eq 1 ] && \
  759. __chroot="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH}"
  760. mount-chroot unionfs_dir
  761. mount-chroot archives_dir
  762. mount-chroot /proc
  763. mount-chroot /dev/pts
  764. mount-chroot /dev/shm
  765. mount-chroot /tmp
  766. # mount-chroot /home
  767. apt-get-update --chroot
  768. ## copy host's configurations of /etc
  769. #passwd shadow group gshadow
  770. for i in resolv.conf hosts; do
  771. cp -pf /etc/${i} ${BUILD_ROOT}/etc
  772. done
  773. cp -Ppf /etc/localtime ${BUILD_ROOT}/etc
  774. $__chroot /bin/bash
  775. # mount-chroot --umount /home
  776. mount-chroot --umount /tmp
  777. mount-chroot --umount /dev/shm
  778. mount-chroot --umount /dev/pts
  779. mount-chroot --umount /proc
  780. mount-chroot --umount archives_dir
  781. mount-chroot --umount unionfs_dir
  782. apt-get-update --host
  783. return 0
  784. }
  785. ##############################################################################
  786. initialize-variables || exit 1
  787. check-parameter $* || exit 1
  788. setup-vbuilder || exit 1
  789. while [ $# -gt 0 ]; do
  790. tmpARG=$1
  791. case $tmpARG in
  792. --profile)
  793. shift
  794. ;;
  795. --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
  796. shift
  797. ;;
  798. --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
  799. ;;
  800. --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
  801. shift
  802. ;;
  803. --build|build|--clean|clean)
  804. ;;
  805. *)
  806. echo unknown option $1
  807. exit 1
  808. ;;
  809. esac
  810. case $tmpARG in
  811. --profile)
  812. ;;
  813. --version)
  814. VERSION=$1
  815. ;;
  816. --arch)
  817. VARCH=$1
  818. ;;
  819. --category)
  820. CATEGORIES=$1
  821. ;;
  822. --fetch-url)
  823. VBOOTSTRAP_FETCH_URL=$1
  824. ;;
  825. --dist-upgrade)
  826. with_dist_upgrade=1
  827. ;;
  828. --unionfs)
  829. with_unionfs=1
  830. ;;
  831. --target)
  832. TARGET=$1
  833. RPM_OPTS="${RPM_OPTS} --target $TARGET"
  834. ;;
  835. --with-compat32)
  836. RPM_OPTS="${RPM_OPTS} --with compat32"
  837. ;;
  838. --rpmbuild-define)
  839. RPM_OPTS="${RPM_OPTS} --define $1"
  840. ;;
  841. --rpmbuild-with)
  842. RPM_OPTS="${RPM_OPTS} --with $1"
  843. ;;
  844. --rpmbuild-without)
  845. RPM_OPTS="${RPM_OPTS} --without $1"
  846. ;;
  847. --sign)
  848. with_sign=1
  849. ;;
  850. --no-install)
  851. with_no_install=1
  852. ;;
  853. --no-build-essential)
  854. with_build_essential=0
  855. ;;
  856. --login)
  857. with_login=1
  858. ;;
  859. --bootstrap-dir)
  860. VBOOTSTRAP_DIR=$1
  861. ;;
  862. --unionfs-dir)
  863. UNIONFS_DIR=$1
  864. ;;
  865. --cache-dir)
  866. CACHE_DIR=$1
  867. ;;
  868. --built-rpms-dir)
  869. BUILT_RPMS_DIR=$1
  870. ;;
  871. --debug)
  872. with_debug=1
  873. ;;
  874. --build-rpm|build-rpm)
  875. RPM_PKG=$1
  876. RPM_Build || exit 1
  877. ;;
  878. --install-rpm|install-rpm)
  879. RPM_PKG=$1
  880. RPM_Install || exit 1
  881. ;;
  882. --remove-rpm|remove-rpm)
  883. RPM_PKG=$1
  884. RPM_Remove || exit 1
  885. ;;
  886. --build|build)
  887. Build || exit 1
  888. ;;
  889. --clean|clean)
  890. Clean || exit 1
  891. ;;
  892. esac
  893. shift
  894. done
  895. RPM_Sign ||:
  896. Login_Chroot ||:
  897. exit